#include "dxfont.h"


FONT::FONT(GAME *newg, char ftexture[], int screenx, int screeny) {
	
	screen_x = (FLOAT)screenx;//float(m_pd3dDevice->GetScreenWidth());
	screen_y =  (FLOAT)screeny;//float(m_pd3dDevice->GetScreenHeight());
	strcpy(fontTexture,ftexture);
	gameinfo=newg;
	D3DTextr_CreateTextureFromFile(fontTexture);
	//D3DTextr_Restore(fontTexture, gameinfo->mm_pd3dDevice);
	for (int i=0;i<MAX_FONT_STRINGS;i++) {
		Strings[i].text=NULL;
		Strings[i].dwInds=NULL;
		Strings[i].chVerts=NULL;
	}
	numStrings=0;
	//Strings=NULL;

}
FONT::~FONT(){
	for (int i=0;i<MAX_FONT_STRINGS;i++) {
		if (Strings[i].text) delete [] Strings[i].text;
		if (Strings[i].dwInds) delete [] Strings[i].dwInds;
		if (Strings[i].chVerts) delete [] Strings[i].chVerts;
	}
}

int FONT::addstring(LPDIRECT3DDEVICE7 m_pd3dDevice, char newstr[], float size, float x, float y,int cmode,
					D3DCOLOR color1,D3DCOLOR color2,D3DCOLOR color3,D3DCOLOR color4) {
	x=x*screen_x/640.0f;
	y=y*screen_y/480.0f;

	if (numStrings>=MAX_FONT_STRINGS) return -1;
	numStrings++;
	int ind=numStrings-1;
	Strings[ind].nNumChars=strlen(newstr);
	Strings[ind].nAllocatedChars=Strings[ind].nNumChars;
	Strings[ind].numInds=6*Strings[ind].nNumChars;
	Strings[ind].numVerts=4*Strings[ind].nNumChars;
	Strings[ind].text=new char[Strings[ind].nNumChars+1];
	strcpy (Strings[ind].text, newstr);
	Strings[ind].fPosX=x;
	Strings[ind].fPosY=y;
	Strings[ind].fPosZ=0.5f;
	float z=0.5f;
	Strings[ind].fSize=size;
	Strings[ind].colorMode=cmode;
	Strings[ind].col1=color1;
	Strings[ind].col2=color2;
	Strings[ind].col3=color3;
	Strings[ind].col4=color4;
	
	//now set up the verts
	float char_spacing_x = CHAR_SPACING_X;
	float char_spacing_y = CHAR_SPACING_Y;

	float ch_size_x, ch_size_y;
	col1=color1;
	col2=color2;
	col3=color3;
	col4=color4;
	ch_size_x = screen_x * Strings[ind].fSize * CHAR_SPACING_X/2.0f;
	ch_size_y = screen_y * Strings[ind].fSize * CHAR_SPACING_Y;
	//col = D3DCOLOR(Strings[s].Color.r,Strings[s].Color.g, Strings[s].Color.b, Strings[s].Color.a);
	//col=D3DRGB(1.0f,1.0f,0.0f);
	Strings[ind].dwInds=new WORD[Strings[ind].numInds];
	Strings[ind].chVerts=new D3DTLVERTEX[Strings[ind].numVerts];
	for (int i=0;i<Strings[ind].nNumChars;i++) {
		float tu=0, tv=0;
		int y_pos = Strings[ind].text[i] / NUM_FONT_CHARS_ACROSS;
		int x_pos = Strings[ind].text[i]  % NUM_FONT_CHARS_ACROSS;
		tu=x_pos/(FLOAT)NUM_FONT_CHARS_ACROSS;
		tv=y_pos*HEIGHT_TO_WIDTH_RATIO/(FLOAT)NUM_FONT_CHARS_ACROSS;
		
		Strings[ind].chVerts[i*4]=D3DTLVERTEX(D3DVECTOR(x+i*(ch_size_x),y,z), 0.9f, col1,  0.0f, tu+0.002f,tv+0.002f);
		Strings[ind].chVerts[i*4+1]=D3DTLVERTEX(D3DVECTOR(x+ch_size_x+i*(ch_size_x),y,z), 0.9f, col2,  0.0f, tu+char_spacing_x-0.002f,tv+0.002f);
		Strings[ind].chVerts[i*4+2]=D3DTLVERTEX(D3DVECTOR(x+i*(ch_size_x),y+ch_size_y,z), 0.9f, col3,  0.0f, tu+0.002f,tv+char_spacing_y-0.002f);
		Strings[ind].chVerts[i*4+3]=D3DTLVERTEX(D3DVECTOR(x+ch_size_x+i*(ch_size_x),y+ch_size_y,z), 0.9f, col4,  0.0f, tu+char_spacing_x-0.002f,tv+char_spacing_y-0.002f);
		
		Strings[ind].dwInds[i*6]=i*4+0;
		Strings[ind].dwInds[i*6+1]=i*4+1;
		Strings[ind].dwInds[i*6+2]=i*4+2;
		Strings[ind].dwInds[i*6+3]=i*4+3;
		Strings[ind].dwInds[i*6+4]=i*4+2;
		Strings[ind].dwInds[i*6+5]=i*4+1;
	}
	return ind;
}

void FONT::changestring(LPDIRECT3DDEVICE7 , int ind, char newstr[]){

	Strings[ind].nNumChars=strlen(newstr);
	
	//this is bad...must reallocate
	if (Strings[ind].nAllocatedChars<Strings[ind].nNumChars) {
		return;
	}
	if (strcmp(newstr, Strings[ind].text)==0) return;//string hasn't changed

	Strings[ind].numInds=6*Strings[ind].nNumChars;
	Strings[ind].numVerts=4*Strings[ind].nNumChars;
	//Strings[ind].text=new char(Strings[ind].nNumChars+1);
	strcpy (Strings[ind].text, newstr);
	//Strings[ind].fPosX=x;
	//Strings[ind].fPosY=y;
	//Strings[ind].fPosZ=0.5f;
	float x=Strings[ind].fPosX;
	float y=Strings[ind].fPosY;
	float z=0.5f;
	//Strings[ind].fSize=size;
	//Strings[ind].colorMode=cmode;
	//Strings[ind].col1=color1;
	//Strings[ind].col2=color2;
	//Strings[ind].col3=color3;
	//Strings[ind].col4=color4;
	
	//now set up the verts
	float char_spacing_x = CHAR_SPACING_X;
	float char_spacing_y = CHAR_SPACING_Y;
	//float screen_x = 640.0f;//float(m_pd3dDevice->GetScreenWidth());
	//float screen_y =  480.0f;//float(m_pd3dDevice->GetScreenHeight());

	float ch_size_x, ch_size_y;
	ch_size_x = screen_x * Strings[ind].fSize * CHAR_SPACING_X/2.0f;
	ch_size_y = screen_y * Strings[ind].fSize * CHAR_SPACING_Y;
	//col = D3DCOLOR(Strings[s].Color.r,Strings[s].Color.g, Strings[s].Color.b, Strings[s].Color.a);
	//Strings[ind].dwInds=new WORD[Strings[ind].numInds];
	//Strings[ind].chVerts=new D3DTLVERTEX[Strings[ind].numVerts];
	for (int i=0;i<Strings[ind].nNumChars;i++) {
		float tu=0, tv=0;
		int y_pos = Strings[ind].text[i] / NUM_FONT_CHARS_ACROSS;
		int x_pos = Strings[ind].text[i]  % NUM_FONT_CHARS_ACROSS;
		tu=x_pos/(FLOAT)NUM_FONT_CHARS_ACROSS;
		tv=y_pos*HEIGHT_TO_WIDTH_RATIO/(FLOAT)NUM_FONT_CHARS_ACROSS;
		
		Strings[ind].chVerts[i*4]=D3DTLVERTEX(D3DVECTOR(x+i*(ch_size_x),y,z), 0.9f, col1,  0.0f, tu+0.002f,tv+0.002f);
		Strings[ind].chVerts[i*4+1]=D3DTLVERTEX(D3DVECTOR(x+ch_size_x+i*(ch_size_x),y,z), 0.9f, col2,  0.0f, tu+char_spacing_x-0.002f,tv+0.002f);
		Strings[ind].chVerts[i*4+2]=D3DTLVERTEX(D3DVECTOR(x+i*(ch_size_x),y+ch_size_y,z), 0.9f, col3,  0.0f, tu+0.002f,tv+char_spacing_y-0.002f);
		Strings[ind].chVerts[i*4+3]=D3DTLVERTEX(D3DVECTOR(x+ch_size_x+i*(ch_size_x),y+ch_size_y,z), 0.9f, col4,  0.0f, tu+char_spacing_x-0.002f,tv+char_spacing_y-0.002f);
		Strings[ind].dwInds[i*6]=i*4+0;
		Strings[ind].dwInds[i*6+1]=i*4+1;
		Strings[ind].dwInds[i*6+2]=i*4+2;
		Strings[ind].dwInds[i*6+3]=i*4+3;
		Strings[ind].dwInds[i*6+4]=i*4+2;
		Strings[ind].dwInds[i*6+5]=i*4+1;
	}

/*
	float ch_size_x, ch_size_y;
	D3DCOLOR col;
		
	ch_size_x = screen_x * Strings[s].fSize * CHAR_SPACING_X;
	ch_size_y = screen_y * Strings[s].fSize * CHAR_SPACING_Y;

	col = D3DRGBA(Strings[s].Color.r,Strings[s].Color.g, Strings[s].Color.b, Strings[s].Color.a);

	// for each char in each string
	for(int c=0;c<Strings[s].nNumChars;c++)
	{
		float x,y,z;
		float tu,tv;
		
		
		tu =Strings[s].Chars[c].tu;
		tv =Strings[s].Chars[c].tv;

		x = Strings[s].fPosX*screen_x + (c * ch_size_x);
		y = Strings[s].fPosY * screen_y;
		z = 0.5f;         
		
		if(pFontTexture != Strings[s].pFontTexture)
		{
			if(Strings[s].pFontTexture != NULL)
				pFontTexture = Strings[s].pFontTexture;
		}
				
		ChVerts[0] = D3DTLVERTEX(VECTOR3(x,y,z), 0.9f, col,  0.0f, tu,tv);
		ChVerts[1] = D3DTLVERTEX(VECTOR3(x+ch_size_x,y,z), 0.9f, col,  0.0f, tu+char_spacing_x,tv);
		ChVerts[2] = D3DTLVERTEX(VECTOR3(x,y+ch_size_y,z), 0.9f, col,  0.0f, tu,tv+char_spacing_y);
		ChVerts[3] = D3DTLVERTEX(VECTOR3(x+ch_size_x,y+ch_size_y,z), 0.9f, col,  0.0f, tu+char_spacing_x,tv+char_spacing_y);

		D3D->DrawTriStrip_Trans(ChVerts, 4, 0);
		//D3D->DrawTriStrip_Trans(ChVerts, 4, 0);

	}
*/
}
void FONT::drawself(LPDIRECT3DDEVICE7 m_pd3dDevice){
	m_pd3dDevice->SetTexture( 0, D3DTextr_GetSurface(fontTexture));
	char buffer[80];
	//sprintf(buffer, "%s"
	//gamelog.addlog("Before font loop");
	int i;
	HRESULT hr;
	for (i=0;i<numStrings;i++) {
		hr=m_pd3dDevice->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, D3DFVF_TLVERTEX ,
				Strings[i].chVerts, Strings[i].numVerts,
				Strings[i].dwInds, Strings[i].numInds, 0 );
//		if (hr!=D3D_OK) gamelog.addlog("d3derror...abort...abort...abort");
//		gamelog.addlog("inside font loop");
		//sprintf(buffer, "%d %d %f %f", Strings[i].numVerts,Strings[i].numInds,Strings[i].chVerts[0].sx,Strings[i].chVerts[0].sy); 
		//gamelog.addlog(buffer);
		//gamelog.addlog(Strings[i].text);
	}
	//gamelog.addlog("After font loop");
}
