#define STRICT
#define D3D_OVERLOADS
#include <math.h>
#include <time.h>
#include <stdio.h>
#include "..\d3dframe\D3DApp.h"
#include "..\d3dframe\D3DTextr.h"
#include "..\d3dframe\D3DUtil.h"
#include "..\d3dframe\D3DMath.h"


//these are all text handler stuff
#define MAX_CHARS_PER_STRING 256
#define MAX_FONT_STRINGS 20
#define NUM_FONT_CHARS_ACROSS 16	// this is fixed - each font .bmp should have 16 chars
									// and must have the correct oredering for each char
// NOTE: This forces all fonts to be twice as long as they are wide! So if you have a
// font texture with chars that are 16 pixels wide, for it to work ... the chars must
// be 32 pixels tall.
#define HEIGHT_TO_WIDTH_RATIO 2.0f
#define CHAR_SPACING_X (1.0f / 16.0f)
#define CHAR_SPACING_Y CHAR_SPACING_X * HEIGHT_TO_WIDTH_RATIO

class GAME;

struct DXSTRING {
	D3DCOLOR col1,col2,col3,col4;
	int colorMode;
	//0		single color
	//1		2 colors gradient right to left over entire string
	//2		2 colors gradient right to left over each char
	//3		2 colors gradient top to bottom
	//4		4 colors gradient over entire string
	//5		4 colors gradient over each char
	D3DTLVERTEX	*chVerts;
	WORD *dwInds;
	char *text;
	int nNumChars;
	int nAllocatedChars;
	DWORD numVerts, numInds;
	float fSize;
	float fPosX;
	float fPosY;
	float fPosZ;
};


class FONT {
public:
	/*
	int MAX_CHARS_PER_STRING;
	int MAX_FONT_STRINGS;
	int NUM_FONT_CHARS_ACROSS;	// this is fixed - each font .bmp should have 16 chars
										// and must have the correct oredering for each char
	// NOTE: This forces all fonts to be twice as long as they are wide! So if you have a
	// font texture with chars that are 16 pixels wide, for it to work ... the chars must
	// be 32 pixels tall.
	float HEIGHT_TO_WIDTH_RATIO;
	float CHAR_SPACING_X;
	float CHAR_SPACING_Y;
	*/
	D3DCOLOR col1;
	D3DCOLOR col2;
	D3DCOLOR col3;
	D3DCOLOR col4;
	char fontTexture[35];
	int numStrings;
	DXSTRING Strings[MAX_FONT_STRINGS];
	GAME *gameinfo;
	float screen_x;//float(m_pd3dDevice->GetScreenWidth());
	float screen_y;//float(m_pd3dDevice->GetScreenHeight());

	//DXCHAR *text;
	//D3DTLVERTEX	*chars;
	FONT(GAME *newg, char ftexture[], int screenx, int screeny);
	~FONT();
	int addstring(LPDIRECT3DDEVICE7, char newstr[], float size, float x, float y, int colormode, 
		D3DCOLOR color1,D3DCOLOR color2,D3DCOLOR color3,D3DCOLOR color4);
	void changestring(LPDIRECT3DDEVICE7, int, char newstr[]);
	void drawself(LPDIRECT3DDEVICE7);
};
